# Generated by Django 4.1.13 on 2023-12-14 08:17

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import utils.unique


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Permission",
            fields=[
                (
                    "id",
                    models.CharField(
                        default=utils.unique.uuid_id,
                        max_length=32,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("is_active", models.BooleanField(default=True, verbose_name="是否激活")),
                (
                    "create_datetime",
                    models.DateTimeField(auto_now_add=True, verbose_name="创建时间"),
                ),
                (
                    "update_datetime",
                    models.DateTimeField(auto_now=True, null=True, verbose_name="更新时间"),
                ),
                ("name", models.CharField(max_length=64, verbose_name="名称")),
                (
                    "description",
                    models.CharField(blank=True, max_length=256, verbose_name="描述"),
                ),
                (
                    "delete_datetime",
                    models.DateTimeField(blank=True, null=True, verbose_name="删除时间"),
                ),
                ("content_type", models.CharField(max_length=64, verbose_name="内容类型")),
                ("action", models.CharField(max_length=64, verbose_name="动作")),
                (
                    "create_user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.RESTRICT,
                        related_name="created_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "delete_user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="deleted_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "update_user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="updated_%(app_label)s_%(class)ss",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "权限表",
                "db_table": "iam_permission",
                "unique_together": {("content_type", "action")},
            },
        ),
    ]
